#<!--
# @markup ruby
# @title Almacena tus dietas
# @author Abián Torres Torres (alu0100887686@ull.edu.es)
#-->
require "prct06/version"
class DslDieta
	include Comparable
	# @overload Método de acceso y escritura para los atributos de instancia.
	attr_accessor :titulo,:max,:min,:vct,:proteinas,:grasas,:hidratos,:platos
	# @note Método por el cual se inicializa la dieta mediante el título y un bloque
  	# @param [String] Título, [Block] Block    
	def initialize(titulo,&block)
		self.titulo=titulo
		self.platos =[]
		if block_given?
			if block.arity == 1
				yield self
			else
				instance_eval(&block)
			end
		end
	end
 	# @note Función que permite mostrar una salida formateada de la lista
  	# @return [String] String con el contenido de la lista
	def  to_s
		output = "#{titulo} (#{min}-#{max}%):\n"
		i=0
		begin
			output+="#{platos[i]}\n"
			i+=1
		end while (i<platos.length)
		output += "V.C.T. | %      #{vct} kcal | #{proteinas}% - #{grasas}% - #{hidratos}%\n"
		"#{output}"
	end
	# @note Función que permite comparar dos dietas en función de sus valor calorífico. 
	# @param [Diet] Menú a comparar
	# @return [Int] 1 if self>other, 0 if self == other, -1 if self<other
	def <=>(other)
		self.vct<=>other.vct
	end
        # @note Función que permite asignar valor a los atributos max y min. 
        # @param [Hash] Parámetro min y max
	def ingesta(args = {})
		self.max="#{args[:max]}" if args[:max]
		self.min="#{args[:min]}" if args[:min]
	end
        # @note Función que permite añadir un nuevo plato a la dieta. 
        # @param [Hash] Parámetros descripcion, porcion y gramos
	def plato(args = {})
		input = "  -#{args[:descripcion]}" if args[:descripcion] 
		input += ", #{args[:porcion]}" if args[:porcion]
		input += ", #{args[:gramos]} gramos" if args[:gramos]
		self.platos << "#{input}"
	end
        # @note Función que permite asignar valor a los parámetros: vct, proteinas, grasas y hidratos. 
        # @param [Hash] Parámetros descripcion, porcion y gramos
	def porcentajes(args = {})
		self.vct="#{args[:vct]}" if args[:vct]
		self.proteinas="#{args[:proteinas]}" if args[:proteinas]
		self.grasas="#{args[:grasas]}" if args[:grasas]
		self.hidratos="#{args[:hidratos]}" if args[:hidratos]
	end
end
