#<!--
# @markup ruby
# @title Almacena tus dietas
# @author Abián Torres Torres (alu0100887686@ull.edu.es)
#-->
require "prct06/version"
class Diet
	
	include Comparable
	  
	#Declaración de los métodos de escritura
	#y lectura para todas las variable de la clase

	# @overload Método de acceso y escritura para el atributo que almacenará el Título
	attr_accessor :ttl #Título
	# @overload Método de acceso y escritura para el atributo que almacenará el Ingesta Diaria
	attr_accessor :dip #Ingesta Diaria
	# @overload Método de acceso y escritura para el atributo que almacenará el Valor calorífico Total
	attr_accessor :vct #Valor calorífico Total
	# @overload Método de acceso y escritura para el atributo que almacenará el Array de platos
	attr_accessor :rcps #Array de platos
	# @overload Método de acceso y escritura para el atributo que almacenará el Porcentaje de proteínas
	attr_accessor :pprtn #Porcentaje de proteínas
	# @overload Método de acceso y escritura para el atributo que almacenará el Porcentaje de grasas
	attr_accessor :pfts #Porcentaje de grasas
	# @overload Método de acceso y escritura para el atributo que almacenará el Porcentaje de hidratos de carbono
	attr_accessor :pchdt #Porcentaje de hidratos de carbono    

	# @note Método por el cual se introduce un elemento por el principio
  	# @param [String] Título, [String] Ingesta diaria, [String] Valor calorífico,
  	# @param [String] Porcentaje de proteínas, [String] Porcentaje de proteínas, [String] Porcentaje de grasas
  	# @param [String] Porcentaje de hidratos de carbono    
    
    def initialize(ttl,dip,vct,pprtn,pfts,pchdt)
        
        @ttl   = ttl #Título
        
        @dip   = dip #Ingesta Diaria
       	
       	@vct   =  vct #Valor calorífico Total
       	
       	@rcps  = Array.new #Array de platos
        
        @pprtn = pprtn #Porcentaje de proteínas
        
        @pfts  = pfts #Porcentaje de grasas
       	
       	@pchdt = pchdt #Porcentaje de hidratos de carbono

    end

    # @note Función que permite mostrar una salida formateada de la lista
  	# @return [String] String con el contenido de la lista

	def to_s()

		tmp = "#{ttl} (#{dip}%)\n"

		i   = 0

		begin

			tmp += "#{rcps[i]}"

			i+=1

		end while (i<rcps.length)

		tmp += "V.C.T. | %      #{vct} kcal | #{pprtn}% - #{pfts}% - #{pchdt}%\n"
		
		"#{tmp}"
	end

	# @note Función que permite añadir un nuevo plato 
	# @param [String] Descripción del plato a añadir

	#Con este método añadimos en el array un nuevo plato
	#siguiendo el formato predefinido.

	def new_recipe(recipe)
		
		tmp = "- #{recipe}\n"
		
		rcps << tmp
	
	end

	# @note Función que permite comparar dos dietas en función de sus valor calorífico. 
	# @param [Diet] Menú a comparar
	# @return [Int] 1 if self>other, 0 if self == other, -1 if self<other

	def <=>(other) 

		@vct <=> other.vct

	end

end
